#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "tetX.h"


extern Display	*display;
extern Window   window;
extern Visual   *visual;
extern Pixmap  screenContext;
extern GC  graphContext;
extern int		screenNumber;

extern int Level, JoyEnabled, ShowNext, Demo;
extern int ScreenWidth, ScanWidth, ScreenHeight, ScreenDepth;
extern int ScreenColours, VideoChipset, ScrollerBusy;
extern long Ticks;

extern char FillPats[10][8];
extern char BgColourName[];
extern int BkgrPatColour[10];
extern int ScrollerBusy, ScrollAvailable;
extern int ShowNext;
extern int FgrColour, BkgrColour, TxtColour, HiliteColour;
extern unsigned long PixValues[16];

extern IMAGE_HEADER Intelligent_Hdr, tetris_Hdr;
extern IMAGE_HEADER  tetris_Hdr;

//static Pixmap  patPixmap=None;

int ScreenBusy;
int BoardX, BoardY, BoardW, BoardH;
int JoyX, JoyY, JoyW, JoyH;
int ScoreX, ScoreY, ScoreW, ScoreH;
int NextX, NextY, NextW, NextH;
int PictureX, PictureY, PictureW, PictureH;


static int  HdrX, HdrY, HdrW, HdrH;
Bool DoInvalidate = 1;

//-------------------------------------------------------------
void InitBoard(void)
{  int BrdRight;


  

   BoardW = BRD_WIDTH * FIG_WIDTH;
   BoardH = BRD_HEIGHT * FIG_HEIGHT;

   BoardY = (ScreenHeight - BoardH) >> 1;
   BoardY -= 10;
//   if (ScreenHeight <= 350) BoardY = 3;
//                      else  BoardY += 8;

   BoardX = (ScreenWidth - BoardW) >> 1;

   // Calculate right window position
   BrdRight = BoardX + BoardW;

   ScoreW = TABLE_WIDTH*8 + 16;
   ScoreX = (ScreenWidth + BrdRight - ScoreW) >> 1;
   ScoreX += 4;
   ScoreY = BoardY;                        // Top alignment
   ScoreH = 88;

   NextX = ScoreX;
   NextW = ScoreW;
   NextH = 92;
   NextY = BoardY + ((BoardH-NextH) >> 1);   // Central alignment

   JoyX = ScoreX;
   JoyW = ScoreW;
   JoyH = 88;
   JoyY = BoardY + BoardH - JoyH;         // Bottom alignment

   PictureW = 160;
   PictureX = (BoardX - PictureW) >> 1;
   PictureH = BoardH;
   PictureY = BoardY;

   TxtColour =  TEXT_COLOUR;
   HiliteColour = HILITE_COLOUR;

   setPalette(&tetris_Hdr, 16);

   HdrW = tetris_Hdr.imwid/2;
   HdrH = tetris_Hdr.imhei/2;
   HdrX = (ScreenWidth - HdrW)>>1; 
   HdrY = (BoardY - HdrH) >> 1;
  


   ScreenBusy = 0;
}

/*
void DeInitBoard(void)
{   if (patPixmap!=None) XFree(display, patPixmap);
*/  

//-------------------------------------------------------------
int  AllocScreenContext(void)
{    DoInvalidate = False;
     return 0;  
} 


int  ScreenToScreenContext(void)
{    return 0;  }

int  InvertPalette(void)
{    return InvertScreenContext();  }

void DeleteScreenContext(void)
{
     DoInvalidate = True;
}



int  ContextRectToScreen(RECT *rect)
{
	

     int x = rect->left;
     int y = rect->top;
     int w = rect->right - x;
     int h = rect->bottom - y;
/*	 static int count =0;
	  printf ("Copy area %d\n", ++count);	 */

     XCopyArea(display, screenContext, window, graphContext, 
	                x, y, w, h, x, y);
     XFlush(display);

     return  0;
}

int  ScreenContextToScreen(void)
{    RECT rc;
     rc.top = rc.left = 0;
     rc.bottom = ScreenHeight;
     rc.right = ScreenWidth;
     ContextRectToScreen(&rc);
     return 0;

}

int  InvertScreenContext(void)
{    XGCValues xgcval;
     
     xgcval.fill_style = FillSolid;
     xgcval.foreground = 1 << ScreenDepth; // PixValues[15-FgrColour];
     xgcval.function   = GXinvert;
     XChangeGC(display, graphContext, 
			GCFunction | GCFillStyle | GCForeground,
			&xgcval); 


     XFillRectangle(display, window, graphContext,
                        0,  0, ScreenWidth, ScreenHeight);
     XFlush(display);

     return 0;

}



/*
void setrow(int x, int y, int wid, unsigned char *row)
{  if (ScreenContext)
   {  unsigned char *ptr = ScreenContext + (ScreenWidth * y + x);
      memcpy(ptr, row, wid);
   }
   else
   { while(ScrollerBusy) pause();
     ScreenBusy = 1;
     vga_drawscansegment(row, x, y, wid);
     ScreenBusy = 0;
   }
}




//-------------------------------------------------------------

int SetStdPlette(void)
{   int Pal[48];
    int *ptr = Pal;
    int i;


   if (VideoChipset == EGA) return 4;

   // Dark colours
   for (i=0; i<7; i++)
   {   *ptr++ = (i & 4) ? 31 : 0;
       *ptr++ = (i & 2) ? 31 : 0;
       *ptr++ = (i & 1) ? 31 : 0;
   }

   // Colour 7 entry (light grey)
   *ptr++ = *ptr++ = *ptr++ = 48;

   // Colour 8 entry (dark grey)
   *ptr++ = *ptr++ = *ptr++ = 31;

   // Light colours
   for (i=9; i<16; i++)
   {   *ptr++ = (i & 4) ? 63 : 0;
       *ptr++ = (i & 2) ? 63 : 0;
       *ptr++ = (i & 1) ? 63 : 0;
   }

   vga_setpalvec(0, 16, Pal);
   return 0;
}
*/
   
//-------------------------------------------------------------
void DrawSolidRect(RECT *rc, int FillColour)
{    XGCValues xgcval;

     xgcval.fill_style = FillSolid;
     xgcval.foreground = PixValues[FillColour];
     xgcval.function   = GXcopy;

     XChangeGC(display, graphContext, 
			GCFunction | GCFillStyle | GCForeground,
			&xgcval); 
     
     XFillRectangle(display, screenContext, graphContext,
                   rc->left, rc->top, 
		   rc->right - rc->left, 
		   rc->bottom - rc->top);

    if (DoInvalidate) ContextRectToScreen(rc);
}

//-------------------------------------------------------------
/* The flag will be ignored in X mode */
void DrawRectWithFrame(RECT *rc1, int flag )
{    
   
     XGCValues xgcval;
     RECT	rc;
     
     memcpy (&rc, rc1, sizeof(RECT));

     rc.left -= 5;  rc.right +=  5;
     rc.top  -= 4;  rc.bottom += 4;     

     xgcval.fill_style = FillSolid;
     xgcval.foreground = PixValues[BkgrColour];
     xgcval.function   = GXcopy;
     XChangeGC(display, graphContext, GCFunction | GCFillStyle | GCForeground, &xgcval);

     XFillRectangle(display, screenContext, graphContext,
                   rc.left, rc.top, 
		   rc.right - rc.left, 
		   rc.bottom - rc.top);


     xgcval.foreground = PixValues[FgrColour];
     xgcval.line_width  = 2;
     xgcval.line_style  = LineSolid;
     XChangeGC(display,  graphContext,
                        GCForeground | GCLineStyle | GCLineWidth, &xgcval);

     rc.left += 3;  rc.right -=  3;
     rc.top  += 3;  rc.bottom -= 3;  
     
     XDrawRectangle(display, screenContext, graphContext,
                   rc.left, rc.top, 
		   rc.right - rc.left, 
		   rc.bottom - rc.top);

     if (DoInvalidate)
     { 
        rc.left -= 3;  rc.right += 3;
        rc.top  -= 3;  rc.bottom += 3;    

       ContextRectToScreen(&rc);
     }  
     
}

void DrawFramedRect(RECT *rc)
{   DrawRectWithFrame(rc, 1); }

void EncompassFramedRect(RECT *rc)
{   DrawRectWithFrame(rc, 0); }




//-------------------------------------------------------------
// Draw patterned rectangle
void DrawPatRect(RECT *rc, char *pattern, int offset)
{
     XGCValues xgcval;
     Pixmap patPixmap;    

    
     		  
     patPixmap =  XCreatePixmapFromBitmapData(display, screenContext,
                  pattern, 8, 8,
  		  PixValues[FgrColour], PixValues[BkgrColour], ScreenDepth);

    if (patPixmap == None) return;     
     
     xgcval.fill_style = FillTiled;
//     xgcval.foreground = PixValues[FgrColour];
//     xgcval.background = PixValues[BkgrColour];
     xgcval.function   = GXcopy;
     xgcval.tile = patPixmap;
     XChangeGC(display, graphContext, 
	GCFillStyle | GCTile | GCFunction, // GCForeground | GCBackground, 
			&xgcval); 


     XFillRectangle(display, screenContext, graphContext,
                 rc->left, rc->top, 
                 rc->right - rc->left, rc->bottom - rc->top);

     if (DoInvalidate) ContextRectToScreen(rc);

     if (patPixmap != None) XFreePixmap(display, patPixmap);		   
}


void DrawBkgrPattern(RECT *rc)
{
   DrawPatRect(rc, FillPats[Level], 0);
}

//-------------------------------------------------------------
static void DrawBackground(void)
{   RECT rc;

    FgrColour = BkgrPatColour[Level];

    rc.top = 0;
    rc.left = 0;
    rc.right = ScreenWidth;
    rc.bottom = ScreenHeight;
    DrawBkgrPattern(&rc);


    rc.top = BoardY;
    rc.left = BoardX;
    rc.right = BoardX + BoardW;
    rc.bottom = BoardY + BoardH;
    DrawFramedRect(&rc);
}

//-------------------------------------------------------------
void  ProceedExposeEvent(XExposeEvent *event) 
{ 
     int  x, y, w, h;

//      if (event->count == 0 )
      { 
	    while(ScreenBusy || ScrollerBusy) pause();   
	    ScreenBusy = 1;
	 
	    if (event->send_event == 0)
        {
	       x = event->x;     y= event->y;
	       w = event->width; h = event->height;
	    }
	    else
	    {
	      x = y = 0;
	      w = ScreenWidth; h = ScreenHeight;
	    }      
	    XCopyArea(display, screenContext, window, graphContext, 
	        x, y, w, h, x, y);
		XFlush(display);			

	    ScreenBusy = 0;
      }

}

void DrawAll(BOARD brd[][BRD_WIDTH])
{  

    DoInvalidate = 0;    
    DrawBackground();

    if (JoyEnabled || Demo) PrepareJoyWindow();

    PrepareScroller();
    
    DrawBoard(brd, 0, BRD_WIDTH, 0, BRD_HEIGHT);

    PrepareStatWindow();
    if (ShowNext) PrepareNextWindow();

    showSqueezedImage(&tetris_Hdr, HdrX, HdrY+5, 0, 2, 2);
    showSqueezedImage(&Intelligent_Hdr, HdrX-6, 1, 0, 3, 3);
    drawpic();
    ScreenContextToScreen();
    DoInvalidate = 1;    
    
}
void DrawSolidLine(int x1, int y1, int x2, int y2, int width, int Colour)
{    XGCValues xgcval;

     xgcval.line_style = LineSolid;
     xgcval.line_width = width;
     xgcval.foreground = PixValues[Colour];
     XChangeGC(display, graphContext, 
			GCLineStyle | GCLineWidth | GCForeground,
			&xgcval); 
     
    XDrawLine(display, screenContext, graphContext, x1, y1, x2, y2);
    
    if (DoInvalidate)
    {  RECT rect;
       rect.top = y1-width; rect.bottom = y2+width;
       rect.left = x1-width; rect.right = x2+width;
       ContextRectToScreen(&rect);
    }   
}

/*
//-----------------------------------------------------------
void DrawPatLine(int x, int y, int width, int pat, int fgr, int bkgr)
{  char pattern[8];
   int  i, m;

   m = 0x80;
   for(i=0; i<8; i++)
   {    pattern[i] = (pat & m) ? fgr : bkgr;
        m >>= 1;
   }

   i = 0;
   while (i<width)
   {  m = 8;
      if (i+m > width) m = width-i;
      setrow(x+i, y, m, pattern);
      i += m;
   }

}
*/


