#include <vga.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <ctype.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include "tetX.h"
#include "kbcodes.h"
#include "keyjoy.h"
#include "egafont.h"

#ifndef HAVE_CONFIG_H
#include "scorefile.h"
#endif

/* Global data */
int ScreenWidth, ScanWidth, ScreenHeight;
int ScreenDepth, VideoChipset;
int VgaVideoMode;
int ScrollAvailable;
int TimerSuspended = 0;
int svgalib_version = 0;
int LoopMode = 1, KillPlayMode = 0; 
int RedirInpMode = 1, RedirOutMode = 1, RedirErrMode = 0;
int Intro = 1;
int Focus = 1;
int BeepsEnabled, MusicEnabled;
char *Player = NULL;
BOTTOM_MODE BottomMode;
WHERE_WE_ARE where;
char *PauseFileName = NULL, *PlayListFileName = NULL;
char *ScoresFileName = NULL;
char BgColourName[41];
long   Ticks = 0;
char  FontFileName[81];
char  FontFileDir[81];
char *VarTexts[VAR_TEXTS];


extern unsigned int Score;             // tetgame.c
extern int  Demo;                      // tetgame.c
extern int  JoyEnabled;                // tetgame.c
extern int  DefLevel, DefLays;         // tetgame.c
extern int  JoyEquiv[4];               // tetgame.c
extern short UseJoystick;              // tetkeyjoy.c 

static   char   *Font = NULL;
static   short   TimerSet = 0;
static   struct itimerval oldvalue;

/* Local data */
enum { EGA_MODE, VGA_MODE, SVGA_MODE, LOW_MODE}  VideoMode;

static char *GetArgument(char *ptr, int *argi, int argc, char *argv[])
{     if (*ptr == '\0' && (*argi) < argc-1)
      {
          char *argp = argv[(*argi)+1];
          if (*argp != '-' && *argp != '/')
          { ptr = argp; (*argi)++; }
      }

      return ptr;
}

static int ProceedArguments(int argc, char *argv[])
{
   int argi;
   char *ptr, c;
   char *modes;

   PlayListFileName = GetFullFileName(BGLIST_FILE_NAME);
   PauseFileName  = GetFullFileName(PAUSE_FILE_NAME);
   ScoresFileName = SCORES_FILE_NAME;
   strcpy(BgColourName, DEFAULT_BG_RGB);
   strcpy(FontFileName, DEFAULT_FONT);

   VarTexts[ScoreTextPos] = SCORE_TEXT;
   VarTexts[LevelTextPos] = LEVEL_TEXT;
   VarTexts[LayersTextPos] = LAYERS_TEXT;
   VarTexts[BonusTextPos] = BONUS_TEXT;
   VarTexts[NextTextPos] = NEXT_TEXT;
   VarTexts[JoyTextPos] = JOYSTICK_TEXT;
   VarTexts[TotalTextPos] = TOTAL_TEXT;
   VarTexts[TopHeaderPos] = TOP_HEADER;

#ifdef SCROLLER_DISABLED
    ScrollAvailable = 0;
#else
    ScrollAvailable = 1;
#endif

#ifdef JOYSTICK_SUPPORTED
   JoyEnabled = JOY_ENABLED_DEFAULT;
#else
   JoyEnabled = 0;
#endif


   DefLevel  = 0;
   DefLays   = 0;
   VideoMode = DEFAULT_VIDEO;
   modes     = DEFAULT_MODES;	

   UseJoystick = 1;  /* New driver interface */
   JoyEquiv[0] = '5';
   JoyEquiv[1] = '0';
   JoyEquiv[2] = '\0';
   JoyEquiv[3] = '\0';

   Demo = 0;
   Intro = 1;

   strcpy(FontFileDir, CONSOLE_FONT_DIR);

   argi = 1;
   while (argi < argc)
    {  ptr = argv[argi];
       c = *ptr++;
       if (c == '/' || c =='-') c = *ptr++;

       c = toupper(c);


       switch(c)
       {//case 'A':
        //    if ( toupper(*(++ptr)) == 'N')
        //           SoundCard = 0;        /* Do not check for Sound Card */
       //     break;

        case 'I':
            Intro = 0;
            break;

#ifdef JOYSTICK_SUPPORTED
       case 'J':
            JoyEnabled = 1;
            ptr = GetArgument(ptr, &argi, argc, argv);
	    { int i;
	      for (i=0; i<4;)
              {  if ((c = *ptr++) == '\0') break;
	         c = toupper(c);
	         if (c == 'O') UseJoystick = 0;
	         else JoyEquiv[i++] = c;
	      }	     
            }
            break;

         case 'K':
            JoyEnabled = 0;
            break;
#endif

	 case 'O':
	    ptr = GetArgument(ptr, &argi, argc, argv);
	    if (ptr) modes = ptr;	 	    
	    break;	 

         case 'L':
            ptr = GetArgument(ptr, &argi, argc, argv);
            c = *ptr;
            if (isdigit(c)) DefLevel = c - '0';
            break;

         case 'R':
            ptr = GetArgument(ptr, &argi, argc, argv);
            c = *ptr;
            if (isdigit(c)) DefLays = c - '0';
            break;

         case 'V':
            ptr = GetArgument(ptr, &argi, argc, argv);
            c = toupper(*ptr);
            if (c == 'L') VideoMode = LOW_MODE;
            else
            if (c == 'V') VideoMode = VGA_MODE;
            else
            if (c == 'E') VideoMode = EGA_MODE;
            break;

         case 'D':
            Demo = 1;
            break;

         case 'M':
            ptr = GetArgument(ptr, &argi, argc, argv);
            if (PlayListFileName) free(PlayListFileName);
            if (strlen(ptr) == 0) PlayListFileName = NULL;
            else PlayListFileName = GetFullFileName(ptr);
            break;

         case 'P':
            ptr = GetArgument(ptr, &argi, argc, argv);
            if (PauseFileName) free(PauseFileName);
            if (strlen(ptr) == 0) PauseFileName = NULL;
            else PauseFileName = GetFullFileName(ptr);
            break;

         case 'S':
            ScrollAvailable = 0;
            break;

         case 'C':
            ptr = GetArgument(ptr, &argi, argc, argv);
            strcpy(BgColourName, ptr);
            break;

         case 'F':
            ptr = GetArgument(ptr, &argi, argc, argv);
            strcpy(FontFileName, ptr);
            break;

         default:
            ShowComHelp();
            return 4;
       }  /* switch(c); */

       argi ++;
    } /* while loop */

    switch(VideoMode)
    {  case EGA_MODE:
           VideoChipset = EGA;
           break;

       case LOW_MODE:
           VideoMode = EGA_MODE;
                                 // No break here!
       default:
           VideoChipset = VGA;
    }

    process_modes(modes);
 
    return 0;
}

void IntervalHandler(int code)
{


    if (TimerSuspended)
    {
       if (TimerSuspended == 2) TimerSuspended = 1;
    }
    else
    {
       Ticks++;
 #ifndef SCROLLER_DISABLED
//     if (where==W_PROLOGUE || (Demo && BottomMode == B_SCROLLER))
       if (Demo && (BottomMode == B_SCROLLER))
              ScrollerTick();
//     else
 #endif
//       if (BottomMode == B_HELP && where == W_GAME)
//         ChangeHelpPage();
    }
    signal(SIGALRM, IntervalHandler);
//  signal(SIGVTALRM, IntervalHandler);
}

void SuspendTimer(void)
{
   TimerSuspended = 1;	
   signal(SIGALRM, SIG_IGN);
//   if (TimerSuspended==1) return;
//   TimerSuspended = 2;
//   while (TimerSuspended == 2);
}

void ResumeTimer(void)
//{  TimerSuspended = 0; }
{ 
   signal(SIGALRM, IntervalHandler);
   TimerSuspended = 0;	
}


static void TerminationProc(void)
{
     DeinitPlayLines();
     if (PlayListFileName) free(PlayListFileName);

     if (TimerSet)
        setitimer(ITIMER_REAL, &oldvalue, &oldvalue);
     TimerSet = 0;
     signal(SIGALRM, SIG_DFL);

     DeinitScroller();
     joyDeinit();

     egaFreeFont(Font);
     deinitPalette();
/*     vga_unlockvc();
     vga_unlockvc();  */
     vga_setmode(TEXT);
     if (Player) free (Player);

}


void TerminationHandler(int code)
{
    TerminationProc();

    exit(8);
}


#if defined(VGA_GOTOBACK) && defined(VGA_COMEFROMBACK)

static void focus_out_routine(void)
{   
    SuspendTimer();
    Focus = 0;	
}

static void focus_in_routine(void)
{
    ResumeTimer();
    Focus = 1;	
}

static void set_background_routines(void)
{
	if (svgalib_version >= 0x1401 || vga_runinbackground_version() == 1)
  {
		vga_runinbackground(VGA_GOTOBACK, focus_out_routine);	
		vga_runinbackground(VGA_COMEFROMBACK, focus_in_routine);
	}
	else
  {
     fprintf(stderr, "No 'run in background' support by svgalib\n");
     fprintf(stderr, "Avoid console switch when scroller is active\n");
  }     
}

#endif  // defined(VGA_GOTOBACK) ... 


int main(int argc, char *argv[])
{  struct itimerval value;
   int (*move_proc)(void);
   char   message[121] = "";
   int    rc;
   int    vgaVideoModes[] = {G640x480x256, G640x480x16, G640x350x16};
   int    m;

   BottomMode = B_NONE;
   rc = ProceedArguments(argc, argv);
   if (rc) return rc;

   rc = 8;

// This works stating from svgalib 1.4.1, otherwise will be 0
 	 svgalib_version = vga_setmode(-1); 

// Preventing vga_init malfunctioning
   if (VideoMode != SVGA_MODE)
               vga_setchipset(VGA);

// Patching a bug in svgalib 1.9.5
   if(svgalib_version >= 0x1900 && svgalib_version < 0x2000)
		setenv("IOPERM", "1", 0);
   
   if (vga_init())
   {   setuid(getuid());
       strcpy(message, "VGA initialization error");
       goto Ret;
   }

   if(svgalib_version >= 0x1900) seteuid(getuid());
   TimerSet = 0;

   InitPlayLines();
   MusicEnabled = (PlayListFileName != NULL);

/*   if (JoyEnabled) */
#ifdef JOYSTICK_SUPPORTED
   { if (joyInit() || joySetParams())
                    JoyEnabled = 0;
   }
#endif

   Font = egaLoadFont(FontFileName, FontFileDir, message);
   if (!Font) { rc = 8; goto Ret; }


#if defined(VGA_GOTOBACK) && defined(VGA_COMEFROMBACK)
   set_background_routines();
#else
   fprintf(stderr, "Upgrade to svgalib 1.2.11+ is recommended\n");
   fprintf(stderr, "Avoid console switch when scroller is active\n");
#endif

   signal(SIGTERM, TerminationHandler);
   signal(SIGKILL, TerminationHandler);


   if (VideoChipset != EGA)
      VideoChipset = vga_getcurrentchipset();

   m =  (VideoMode == SVGA_MODE) ? 0 :
        (VideoMode == VGA_MODE)  ? 1 : 2;

   while (m<3)
   {  VgaVideoMode = vgaVideoModes[m];
      if (!vga_setmode(VgaVideoMode)) break;
      m++;
   }

   if (m>=3)
   { strcpy(message, "None of possible modes are supported by your card");
     goto Ret;
   }

   ScreenWidth = vga_getxdim();
   ScreenHeight = vga_getydim();
   //SreenColours = vga_getcolors();
   m = vga_getcolors();
   if (m==16) ScreenDepth = 4; else ScreenDepth = 8;

   initPalette();
   if (ScreenDepth == 4) ScanWidth = ScreenWidth >> 3;
              else      ScanWidth = ScreenWidth;

   egaSetFont(Font);

   InitBoard();
   InitScroller();

/*   vga_lockvc(); */


   /* Making tick equal to standard PC interval timer tick */
   value.it_interval.tv_sec = value.it_value.tv_sec = 0l;
   value.it_interval.tv_usec = value.it_value.tv_usec = 10000000l / 182 ;

   /* Getting player name */
   Player = GetPlayerName();	

   setitimer(ITIMER_REAL, &value, &oldvalue);
   TimerSet = 1;
   signal(SIGALRM, IntervalHandler);

   if (Intro)
   {  rc = ShowPrologue();
      if (rc == 8) goto Ret;
      if (rc == 4) Demo = 1;
   }

   InitIntergameScreen();

   if(Demo == 0)
   {
       Score = 0;
       rc = 4;
       if (ShowIntergameScreen()) goto Ret;

   }

   rc = 0;

/* Play game */

    while(rc>=0)
    {

       NewGame();

       move_proc = Demo ? move_demo_figure : move_figure;
       
       do
       {
         if (Focus) rc=(*move_proc)();
       } while (rc == 0 );
       
       if ( EndGame(rc-4) > 0) break;

     }  /* while(rc); */

     rc = 0;


Ret:
     TerminationProc();

     if (rc > 4 && strlen(message)>0) printf("%s\n", message);
     return rc;
}


